# Introduction

The Gyrokinetic Toroidal Code (GTC) is a particle-in-cell simulation of plasma instabilities and turbulence in fusion devices. 

## Website
http://phoenix.ps.uci.edu/gtc/

# Notes to Developers

## File Tree

### Source Files

All the source files, including the ``Makefile``, should be located in the ``src/`` folder. 

### Generic Input Files

A generic ``gtc.in`` file is maintained in ``input/`` folder. This file should be updated if new input parameters are added. 

Input data files are not required to be included in the Git repository if its too large. A link to the path on the phoenix server is strongly encouraged.

New input data file name convention needs to be added into the ``input/DataFileFormat.md`` file.

### Benchmark Record Files

Extensive benchmarks are done for every master level release. The full records are stored on the phoenix server. The input files for each benchmark case
are located in the ``benchmarkInputFiles/`` folder, under the corresponding version numbered folders. 

### Platform Dependent Scripts

Job submission helper scripts are located in the ``jobFiles/`` folder. Modifications may be needed.

### Documentation and Supplimentary Materials

Developer or User oriented documentations are located in ``Doc/`` folder.    

# License
The GTC code is published under the 3-clause BSD license. The full content of the license is in the *LICENSE* file. 
All users should refer to the license file for the requirements on publishing and redistributing the original and/or derived codes of GTC.

