#key parameters:
OPENMP=n
DOUBLE_PRECISION=y
ADIOS=n
BIGDATA=n
PETSc=y
DEBUG=n
GPU=n
GPU_UM=n
COMPILER=gnu
EQ_test=n     # unit test equilibrium wrapper
#ICONFIG=TOKAMAK
ICONFIG=FRC

############################################################################
#             Makefile to build the GTC code
#           ==================================
#
# You only need to type "gmake" to build the code on the platforms
# defined below. The makefile runs the "uname -s" command to detect
# the operating system automatically. Other options are:
#
#  % gmake OPENMP=y       Builds the code with OpenMP support
#  % gmake OPENMP=n       Builds the code WITHOUT OpenMP support
#                         The default is with OpenMP support	
#
#  % gmake DOUBLE_PRECISION=y  Builds with 8-byte floating point precision
#                              The default is single precision
#
#  % gmake PETSc=y        Builds the code using the PETSc parallel matrix
#                         solving library.  This is necessary to run the
#                         electromagnetic version of GTC.
#
#  % gmake DEBUG=y        Compiles the files with debugging flags.
#                         The default is no debug option.
#
#  If COMPILER is set to 'default' the Makefile will select the appropriate
#  compiler for the target.  If the user wished to override the target
#  machine default, COMPILER may be set to 'portland', 'intel', or 'gnu'.
#
# Special targets:
#
#  % gmake clean      Removes the executable and all object files (*.o)
#
#  % gmake cleanomp   Removes the executable and the object files
#                     containing OpenMP directives
#
#  % gmake doc        Rebuilds the documentation.
#
#############################################################################
# cori
CMP := ftn
PETSC_INCLUDE = -I${PETSC_DIR}/include -I${PETSC_DIR}/include/petsc/finclude
NETCDF_INCLUDE = -I${NETCDF_DIR}/include
NETCDF_LIB = -L${NETCDF_DIR}/lib -lnetcdf
LIBD = /global/u2/x/xiao/AdioFranklin/lib
INCD = /global/u2/x/xiao/AdioFranklin/include
ADIOS_INCLUDE = -I$(INCD)
ADIOS_LIB = -L$(LIBD)-ladios -lmxml

