#key parameters:
OPENMP=n
DOUBLE_PRECISION=y
ADIOS=n
BIGDATA=n
PETSc=y
DEBUG=n
GPU=n
GPU_UM=n
COMPILER=portland
EQ_test=n     # unit test equilibrium wrapper
#ICONFIG=TOKAMAK
ICONFIG=FRC

############################################################################
#             Makefile to build the GTC code
#           ==================================
#
# You only need to type "gmake" to build the code on the platforms
# defined below. The makefile runs the "uname -s" command to detect
# the operating system automatically. Other options are:
#
#  % gmake OPENMP=y       Builds the code with OpenMP support
#  % gmake OPENMP=n       Builds the code WITHOUT OpenMP support
#                         The default is with OpenMP support	
#
#  % gmake DOUBLE_PRECISION=y  Builds with 8-byte floating point precision
#                              The default is single precision
#
#  % gmake PETSc=y        Builds the code using the PETSc parallel matrix
#                         solving library.  This is necessary to run the
#                         electromagnetic version of GTC.
#
#  % gmake DEBUG=y        Compiles the files with debugging flags.
#                         The default is no debug option.
#
#  If COMPILER is set to 'default' the Makefile will select the appropriate
#  compiler for the target.  If the user wished to override the target
#  machine default, COMPILER may be set to 'portland', 'intel', or 'gnu'.
#
# Special targets:
#
#  % gmake clean      Removes the executable and all object files (*.o)
#
#  % gmake cleanomp   Removes the executable and the object files
#                     containing OpenMP directives
#
#  % gmake doc        Rebuilds the documentation.
#
#############################################################################
# summit

CMP := mpif90
HDF5_INCLUDE := -I${OLCF_HDF5_ROOT}/include
HDF5_LIB := -L${OLCF_HDF5_ROOT}/lib -lhdf5_fortran
PETSC_INCLUDE := -I${PETSC_DIR}/include -I${PETSC_DIR}/include/petsc/finclude
PETSC_LIB:= -L${PETSC_DIR}/lib -lpetsc
ADIOS_INCLUDE :=
ADIOS_LIB:=
